#include <sourcemod>
#include <hacks>

#define PLUGIN_VERSION "0.1.0"

#define MAX_HITGROUPS		9
#define	HITGROUP_GENERIC	0
#define	HITGROUP_HEAD		1
#define	HITGROUP_CHEST		2
#define	HITGROUP_STOMACH	3
#define HITGROUP_LEFTARM	4
#define HITGROUP_RIGHTARM	5
#define HITGROUP_LEFTLEG	6
#define HITGROUP_RIGHTLEG	7
#define HITGROUP_GEAR		10

new bool:g_bHitgroups[MAX_HITGROUPS] = { true, ... };

new String:g_sHitgroups[MAX_HITGROUPS][10] = { "Generic", "Head", "Chest", "Stomach",
                                               "L.Arm", "R.Arm", "L.Leg",
                                               "R.Leg", "Gear"
                                             };

new g_iHooks[MAXPLAYERS + 1];

new Handle:hgr_enable;
new Handle:hgr_hitgroups;
new Handle:hgr_chatcmd;

new String:g_sChatCMD[255] = "/hitgroups";

public Plugin:myinfo =
{
	name = "Hitgroup Restrictions",
	author = "Knagg0",
	description = "",
	version = PLUGIN_VERSION,
	url = "http://www.mfzb.de"
};

public OnPluginStart()
{
	CreateConVar("hgr_version", PLUGIN_VERSION, "", FCVAR_PLUGIN | FCVAR_REPLICATED | FCVAR_NOTIFY);

	hgr_enable = CreateConVar("hgr_enable", "1", "", FCVAR_PLUGIN);
	hgr_hitgroups = CreateConVar("hgr_hitgroups", "1 1 1 1 1 1 1 1 1", "", FCVAR_PLUGIN);
	hgr_chatcmd = CreateConVar("hgr_chatcmd", g_sChatCMD, "", FCVAR_PLUGIN);

	HookEvent("player_say", Events, EventHookMode_Post);

	HookConVarChange(hgr_hitgroups, ConVarCallback);
	HookConVarChange(hgr_chatcmd, ConVarCallback);
}

public OnClientPutInServer(client)
{
	g_iHooks[client] = Hacks_Hook(client, HACKS_HTYPE_TRACEATTACK, TraceAttack, false);
}

public OnClientDisconnect(client)
{
	Hacks_Unhook(g_iHooks[client]);
}

public TraceAttack(client, inflictor, attacker, damage, hitbox, hitgroup)
{
	if(!GetConVarBool(hgr_enable))
		return Hacks_Continue;

	if(hitgroup == HITGROUP_GEAR) hitgroup -= 2;
	if(hitgroup < 0 || hitgroup >= MAX_HITGROUPS) hitgroup = 0;

	if(!g_bHitgroups[hitgroup])
		return 0;

	return Hacks_Continue;
}

public Action:Events(Handle:event, const String:name[], bool:dontBroadcast)
{
	if(!GetConVarBool(hgr_enable))
		return Plugin_Continue

	new String:sText[255];
	GetEventString(event, "text", sText, sizeof(sText));

	new iClient = GetClientOfUserId(GetEventInt(event, "userid"));

	if(iClient > 0 && StrEqual(g_sChatCMD, sText))
	{
		sText = "\x01";

		for(new i = 0; i < MAX_HITGROUPS; i++)
			Format(sText, sizeof(sText), "%s%s%s=%s", sText, (i > 0) ? ", " : "", g_sHitgroups[i], (g_bHitgroups[i]) ? "\x04On\x01" : "\x03Off\x01");

		PrintToChat(iClient, sText);
	}

	return Plugin_Continue
}

public ConVarCallback(Handle:convar, const String:oldValue[], const String:newValue[])
{
	new String:sName[50];
	GetConVarName(convar, sName, sizeof(sName));

	if(StrEqual("hgr_chatcmd", sName))
		StrCopy(g_sChatCMD, sizeof(g_sChatCMD), newValue);
	else
	{
		new String:sArr[MAX_HITGROUPS][2];

		new iTotal = ExplodeString(newValue, " ", sArr, MAX_HITGROUPS, 2);
		if(iTotal == 0) strcopy(sArr[iTotal++], 2, newValue);

		for(new i = 0; i < MAX_HITGROUPS; i++)
		{
			if(i >= iTotal) g_bHitgroups[i] = true;
			else g_bHitgroups[i] = (sArr[i][0] == '0') ? false : true;
		}
	}
}